﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Reflection;

namespace Multi_Threading
{
    public partial class Form1 : Form
    {
        private static int maxRecords = 100;
        frmProcess myProcess;
        public Form1()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (this.backgroundWorker1.IsBusy)
            {
                return;
            }

            myProcess = new frmProcess();
            myProcess.StartPosition = FormStartPosition.CenterScreen;
            myProcess.pbProcess.Value = 0;
            myProcess.lblProcesstext.Text = "0%";
            myProcess.Show();
            myProcess.TopMost = true;

            this.listBox1.Items.Clear();
            this.backgroundWorker1.RunWorkerAsync(maxRecords);
            this.btnStart.Enabled = false;
            this.btnCancle.Enabled = true;
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
                e.Result=this.RetrieveData(this.backgroundWorker1,e);
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
                throw;
            }
        }

        private int RetrieveData(BackgroundWorker backgroundWorker, DoWorkEventArgs e)
        {
            int SumRecords = (int)e.Argument;
            int pecent = 0;
            for (int i = 0; i < SumRecords; i++)
            {
                if (backgroundWorker.CancellationPending)
                    return i;
                pecent = (int)((double)i / (double)SumRecords * 100);
                backgroundWorker.ReportProgress(pecent, new KeyValuePair<int, string>(i, Guid.NewGuid().ToString()));
                Thread.Sleep(1000);
                    
            }
            return SumRecords;
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            KeyValuePair<int, string> record = (KeyValuePair<int, string>)e.UserState;

            this.lblProcess.Text =

                 string.Format("There are {0} records retrieved!", record.Key);



            this.progressBar1.Value = e.ProgressPercentage;

            myProcess.pbProcess.Value = e.ProgressPercentage;
            myProcess.lblProcesstext.Text = e.ProgressPercentage + "%";

            this.listBox1.Items.Add(record.Value);
        }

        private void btnCancle_Click(object sender, EventArgs e)
        {
            this.backgroundWorker1.CancelAsync();
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            try
            {

                myProcess.Close();
                this.lblProcess.Text = string.Format("Total records: {0}", e.Result);

                this.btnStart.Enabled = true;
                this.btnCancle.Enabled = false;

            }

            catch (TargetInvocationException ex)
            {

                MessageBox.Show(ex.InnerException.GetType().ToString());

            }
        }
    }
}
